//////////////////////////////////////////////////////////////////////////////
//   ///////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "_MATH_Noise.h"
#include "_DRAW_2D.h"

//////////////////////////////////////////////////////////////////////////////
int keyExit = 0, preset = 1, HelpTimer = 0, fun = 0;
tfloat offs = 347.347, offs_san, size_san, dir = -1; 
dwRGB c1, c2, cf;
Noise2D ns;

//////////////////////////////////////////////////////
void landscape(tfloat lev0, tfloat lev, tfloat sw, tfloat sc, tfloat ofs, tfloat ofs_x, dwRGB c, dwRGB cw)
{
  int ex = no, xi = ofs;
  tfloat z, e, n, x = 0, y, xs = 2500 - 2000 * sw + ofs_x, xe = 2500 + 2000 * sw + ofs_x, d = xe - xs;
  DrawPolyNew(); DrawPolyTo(0, DrawYR * (1 - lev0 + 0.03 * sc) + 0.5);
  while (!ex)
  { ex = (x > DrawXR);
    z = xs + d * x / DrawXR;
    e = 0.3 * sc * Lower(ns.GetNs(z, ofs, interpCAVE, 0.09 * sc) * ns.Noise(z * 0.74, ofs + 2437, 2, interpLINEAR), 0.5);
    n = lev + e + 0.1 * (0.1 + e) * sc * ns.Noise(z * 7.2, ofs, 3, interpLINEAR);
    DrawPolyTo(x, DrawYL - n * DrawYL);
    if (fun)
    { xi = (xi + 1) %(int)(55 * Lower(sc, 0.65));
      if (!xi) DrawCircle(x, DrawYL - (n - sc * 0.02 + sc * 0.04 * ns.GetNs(z * 15, ofs + 1277, interpLINEAR)) * DrawYL, 0.5 + fun * Lower(sc, 0.7) * ns.GetNs(z * 5, ofs, no), cw);
    };  
    x += 1.5; 
  };
  DrawPolyTo(DrawXR, DrawYR * (1 - lev0 + 0.03 * sc) + 0.5); DrawPoly(c);
};/**/

/////////////////////////////////////////////////////////////////////////////////////////
void presetChange()
{
  preset = (preset + 1) % 4;
  switch(preset)
  { case 0: c1 = RGBis(70, 0, 0); c2 = RGBis(255, 70, 0); break;
    case 1: c1 = RGBis(0, 25, 75); c2 = RGBis(0, 125, 255); break;
    case 2: c1 = RGBis(70, 0, 35); c2 = RGBis(255, 135, 0); break;
    case 3: c1 = RGBis(25, 50, 0); c2 = RGBis(155, 225, 0); break;
  };
};

void keyPressed()                           //  [ ] 
{
  if (II.KeyUp[_Space_]) fun = (fun + 25) % 150;
  if (II.KeyUp[_Backspace_]) cf = 0xffffffff - cf;
  if (II.KeyUp[_Enter_]) presetChange();
  if (II.KeyUp[_CL_]) dir = 1;
  if (II.KeyUp[_CR_]) dir = -1;
  if (II.KeyUp[_F1_]) if (HelpTimer) HelpTimer = 0; else HelpTimer = 25 * 10;
  keyExit = (II.KeyUp[_Esc_]);
  II.Reset();
};

//////////////////////////////////////////////////////////////////////////////
TextSPR *info;

/////////////////////////////////////////////////////////////////////////////////////////////////
void CommonsInit()
{ 
  FC_FpsSet(AUTO);             //    
  FC_DrawPaint = Yes;          //  fps   DrawPaint();

  RandomSeed();
  Draw2D_Init(); ForceActivate(); ScreenLoadWait();
  info = new TextSPR(L"TYPE_EN_RU"); info->LineSpace = 4;
  OnKeyUpDo(keyPressed);       //     
  presetChange();

  offs_san = DrawXR * 0.75; size_san = DrawYR / 2;
  
  ns.Make(50, 50, 100);
  II.Reset();
};


//////////////////////////////////////////////////////////////////////////////////////////////////
void CommonsDone()
{
  delete info;
  Draw2D_Done();
};

//////////////////////////////////////////////////////////////////////////////////////////////////
int infoDrawed = no;
void DrawInfo()
{
  if (!HelpTimer) return;
  HelpTimer--;
  infoDrawed = Yes;
  tRegion r = RegionCenterIs(210, 180);
  DrawRegionStore.Save(r);
  tfRegion fr = RegionTofRegion(r);
  fDrawRoundRect(fr, 20, RGBis(50, 50, 50), modeMUL); 
  info->Place(0, 0, modeADD + fromCC, "Conrol Keys:\n\nEnter - Change Color\nCursor - Change Direction\n......................................................................................\nSpace - Change Fun Size\nBackspace - Change Fun Color\n......................................................................................\nF1 - hide/show Help\nEsc - Exit");
  info->Draw();
};

//////////////////////////////////////////////////////////////////////////////////////////////////
void RestoreInfo()
{
  if (!infoDrawed) return;
  DrawRegionStore.Restore();
  infoDrawed = no;
};

//////////////////////////////////////////////////////////////////////////////////////////////////
int levels = 8; // 0..8 = 9

void Landscape()
{
  offs += 1 * dir; if (fabs(offs) > 347000000) offs = 347.347;
  offs_san += 0.333 * dir; if (offs_san < -size_san) offs_san = DrawXR + size_san;
  for (int i = 0; i <= levels; i++)
  { tfloat k = (tfloat)i / levels, lev0;
    if (i == levels) lev0 = 0; else lev0 = 0.4 - Lower((tfloat)(i + 1) / levels, 0.70) * 0.3;
    landscape(lev0, 0.4 - Lower(k, 0.70) * 0.3, 0.6 - 0.5 * k, 0.2 + 0.8 * Lower(k, 0.5), offs * 0.26 + k * 1000, -offs, RGBblend(c2, c1, 15 + k * 240), RGBblend(c2, cf, 15 + k * 240));
  };
};

void DrawAll()
{
  DrawFill(RGBblend(c1, c2, 235));
  fDrawCircle(offs_san, DrawYR * 0.6, size_san, RGBblend(c1, c2, 255));

  Landscape();
  
  DrawInfo(); 
  DrawPaint();
  RestoreInfo();
};

//////////////////////////////////////////////////////////////////////////////
//   //////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
void Main()
{
  CommonsInit();                  //   ;  
  
  while (!keyExit) DrawAll();

  CommonsDone();                  //   ;
};
//////////////////////////////////////////////////////////////////////////////
int LetProcess()
{
  //MouseShowCursor = no;
  WinName = L"CG : Landscape";   //    
  VS_CColor = RGBis(0, 0, 0);   //   
  DrawSet(FullScreen);          //   ( )  , FullScreen   
  ProcessFunc = Main;            //    -  
  return on;
};
int Init_LetProcess = LetProcess();

